-----------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    16:29:44 11/02/2009 
-- Design Name: 
-- Module Name:    mux_out_tb - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
-----------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;
use WORK.MUX_PKG.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity mux_out_tb is
end mux_out_tb;

architecture Behavioral of mux_out_tb is

COMPONENT mux_out
PORT(
	regs_in : IN MUX_BANK;
	reg_adr : IN std_logic_vector(4 downto 0);          
	reg_out : OUT std_logic_vector(7 downto 0)
);
END COMPONENT;

signal in_registers : MUX_BANK;
signal address : std_logic_vector(4 downto 0);
signal output : std_logic_vector(7 downto 0);

constant change_time: TIME := 100 us;

begin

init_regs: process
begin
	for I in 31 downto 0 loop
		in_registers(I) <= std_logic_vector(to_unsigned(I,8));
	end loop;
	wait;
end process init_regs;

adr_sweep: process
begin
	for K in 31 downto 0 loop
		address <= std_logic_vector(to_unsigned(K,5));
		wait for change_time;
	end loop;
	wait;
end process adr_sweep;

Inst_mux_out: mux_out PORT MAP(
	regs_in => in_registers,
	reg_out => output,
	reg_adr => address
);

end Behavioral;
